routes/web.php
<?php

use App\Http\Controllers\AlumnoController;
use App\Http\Controllers\CursoController;
use App\Http\Controllers\PerteneceController;
use App\Http\Controllers\PracticaController;
use App\Http\Controllers\PresentaController;
use Illuminate\Support\Facades\Route;

Route::get('/', function () {
    return view('index');
})->name('inicio');

Route::resource('alumno', AlumnoController::class);
Route::resource('curso', CursoController::class);
Route::resource('practica', PracticaController::class);
Route::resource('pertenece', PerteneceController::class);
Route::resource('presenta', PresentaController::class);


// Enrutamiento adicional para practicas
Route::controller(PracticaController::class)->group(function () {
    Route::get('/practica/confirmar/{practica}', 'confirmar')->name('practica.confirmar');
});

// Enrutamiento adicional para Pertenece
Route::controller(PerteneceController::class)->group(function () {
    Route::get('/pertenece/confirmar/{pertenece}', 'confirmar')->name('pertenece.confirmar');
});

// Enrutamiento adicional para Presenta
Route::controller(PresentaController::class)->group(function () {
    Route::get('/presenta/confirmar/{presenta}', 'confirmar')->name('presenta.confirmar');
});

app/Models/Pertenece.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\BelongsTo;
use Illuminate\Support\Facades\Schema;

class Pertenece extends Model {
    use HasFactory;

    protected $table = 'perteneces';

    // Campos de asignación masiva
    protected $fillable = [
        'curso_id',
        'alumno_id',
    ];

    // Nombre de los campos  de las tablas
    public static $labels = [
        'id' => 'ID Pertenece',
        'curso_id' => 'ID Curso',
        'alumno_id' => 'ID Alumno',
        'nombrealumno' => 'Nombre Alumno',
        'nombrecurso' => 'Nombre Curso',
    ];

    /**
     ** Recupera la lista de campos de la tabla asociada al modelo.
     *
     * @return array La lista de nombres de campos.
    */
    public function getFields(): array {
        return Schema::getColumnListing($this->table);
    }

    /**
     ** Recupera la etiqueta de un atributo dado.
     *
     * @param string $attribute El nombre del atributo.
     * @return string La etiqueta del atributo, o el nombre del atributo si no se encuentra una etiqueta.
    */
    public function getAttributeLabel($attribute): string {
        return self::$labels[$attribute] ?? $attribute;
    }

    /**
     ** Obtiene la lista de campos de la modelo de tabla asociada.
     *
     * @return array|BelongsTo La lista de nombres de campos asociados a Alumno.
    */
    public function alumno() : BelongsTo {
        return $this->belongsTo(Alumno::class, 'alumno_id');
    }

    /**
     ** Obtiene la lista de campos de la modelo de tabla asociada.
     *
     * @return array|BelongsTo La lista de nombres de campos asociados a Practica.
    */
    public function curso() : BelongsTo {
        return $this->belongsTo(curso::class, 'curso_id');
    }

    /**
     ** Obtiene el valor del atributo "nombre" del modelo "alumno" asociado.
     *
     * @return string El valor del atributo "nombre".
    */
    public function getNombreAlumnoAttribute(): string {
        return $this->alumno->nombre;
    }

    /**
     ** Obtiene el valor del atributo "nombre" del modelo "curso" asociado.
     *
     * @return string El valor del atributo "nombre".
    */
    public function getNombreCursoAttribute(): string {
        return $this->curso->nombre;
    }
}

app/Http/Controllers/PerteneceController.php
<?php

namespace App\Http\Controllers;

use App\Http\Requests\PerteneceStoreRequest;
use App\Http\Requests\PerteneceUpdateRequest;
use App\Models\Alumno;
use App\Models\Curso;
use App\Models\Pertenece;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;

class PerteneceController extends Controller {
    /**
     * Display a listing of the resource.
     */
    public function index() {
        $perteneces = Pertenece::all();

        return view('pertenece.index', compact('perteneces'));
    }

    /**
     * Show the form for creating a new resource.
     */
    public function create() {
        $alumnos = Alumno::all();
        $cursos = Curso::select('id', 'nombre')->get();

        return view('pertenece.create', compact('alumnos', 'cursos'));
    }

    /**
     * Store a newly created resource in storage.
     */
    public function store(PerteneceStoreRequest $request) {
        $pertenece = Pertenece::create($request->all());

        return redirect()
            ->route('pertenece.show', $pertenece)
            ->with('mensaje', 'Pertenece se ha creado con éxito')
        ;
    }

    /**
     * Display the specified resource.
     */
    public function show(Pertenece $pertenece) {
        return view('pertenece.show', compact('pertenece'));
    }

    /**
     * Show the form for editing the specified resource.
     */
    public function edit(Pertenece $pertenece) {
        $alumnos = Alumno::all();
        $cursos = Curso::select('id', 'nombre')->get();

        return view('pertenece.edit', compact('pertenece', 'alumnos', 'cursos'));
    }

    /**
     * Update the specified resource in storage.
     */
    public function update(PerteneceUpdateRequest $request, Pertenece $pertenece) {
        $pertenece->update($request->all());

        return redirect()
            ->route('pertenece.show', $pertenece)
            ->with('mensaje', 'Pertenece actualizado con éxito')
        ;
    }

    /**
     * Remove the specified resource from storage.
     */
    public function destroy(Pertenece $pertenece) {
        $pertenece->delete();

        return redirect()
            ->route('pertenece.index')
            ->with('mensaje', 'Pertenece borrado con éxito')
        ;
    }

    public function confirmar(Pertenece $pertenece) {
        return view('pertenece.confirmar', compact('pertenece'));
    }
}

resources/views/pertenece/confirmar.blade.php
@extends('layouts.main')

@section('content')
    <h1>Eliminar Pertenece</h1>

    <div>
        <a href="{{ route('pertenece.index') }}" class="boton">Volver</a><br><br>
    </div>

    <div class="listtado">
        <div class="tarjeta">
            <ul>
                <li><a href="{{ route('pertenece.show', $pertenece) }}" >ID:</a> {{ $pertenece->id }}</li>
                <li>Alumno ID: {{ $pertenece->alumno_id }} - {{ $pertenece->alumno->nombre }}</li>
                <li>Curso ID: {{ $pertenece->curso_id }} - {{ $pertenece->curso->nombre }}</li>
            </ul>

            <div class="botones">
                <form action="{{ route('pertenece.destroy', $pertenece)}}" method="POST" class="form-inline">
                    @csrf @method('DELETE')
                    <button class="boton" type="submit">Borrar</button>
                </form>
            </div>
        </div>
    </div>
@endsection

resources/views/pertenece/create.blade.php
@extends('layouts.main')

@section('content')
    <h1>Crear Pertenece</h1>

    @if ($errors->any())
        <div class="">
            <div class="" style="">
                <h2 class="">Error</h2>

                @foreach ($errors->all() as $error)
                    <p class=""> {{ $error }} </p>
                @endforeach
            </div>
        </div>
    @endif

    <a href="{{ route('pertenece.index') }}" class="boton">Volver</a>

    <form action="{{ route('pertenece.store') }}" method="POST" enctype="multipart/form-data">
        @csrf

        <div>
            <label for="alumno_id">Alumno ID</label>

            <select name="alumno_id" id="alumno_id">
                <option value="">-- Seleccione --</option>

                @foreach ($alumnos as $alumno)
                    <option value="{{ $alumno->id }}">{{ $alumno->nombrecompleto }}</option>
                @endforeach
            </select>
        </div>

        <div>
            <label for="curso_id">Curso ID</label>

            <select name="curso_id" id="curso_id">
                <option value="">-- Seleccione --</option>

                @foreach ($cursos as $curso)
                    <option value="{{ $curso->id }}">{{ $curso->nombre }}</option>
                @endforeach
            </select>
        </div>

        <div>
            <button class="boton" type="submit">Crear</button>
        </div>
    </form>
@endsection

resources/views/pertenece/edit.blade.php
@extends('layouts.main')

@section('content')
    <h1>Editar Pertenece</h1>

    @if (session('mensaje'))
        <div class="">
            <div class="" style="background-color: gray">
                <p class="">{{ session('mensaje') }} </p>
            </div>
        </div>
    @endif

    @if ($errors->any())
        <div class="">
            <div class="" style="background-color: gray">
                <h2 class="">Error</h2>
                @foreach ($errors->all() as $error)
                    <p class=""> {{ $error }} </p>
                @endforeach
            </div>
        </div>
    @endif

    <br><a href="{{ route('pertenece.index') }}" class="boton">Volver</a><br><br>

    <form action="{{ route('pertenece.update', $pertenece) }}" method="POST"  enctype="multipart/form-data">
        @csrf
        @method('PUT')

        <div>
            <label for="alumno_id">Alumno ID</label>

            <select name="alumno_id" id="alumno_id">
                @foreach ($alumnos as $alumno)
                    <option value="{{ $alumno->id }}" {{ $pertenece->alumno_id == $alumno->id ? 'selected' : '' }}>{{ $alumno->nombrecompleto }}</option>
                @endforeach
            </select>
        </div><br>

        <div>
            <label for="curso_id">Curso ID</label>

            <select name="curso_id" id="curso_id">
                @foreach ($cursos as $curso)
                    <option value="{{ $curso->id }}" {{ $pertenece->curso_id == $curso->id ? 'selected' : '' }}>{{ $curso->nombre }}</option>
                @endforeach
            </select>
        </div><br>

        <div>
            <button class="boton" type="submit">Actualizar</button>
        </div>
    </form>
@endsection

resources/views/pertenece/index.blade.php
@extends('layouts.main')

@section('content')
    <h1>Listado Perteneces</h1>

    <div>
        <a href="{{ route('pertenece.create') }}" class="boton">Crear Pertenece</a><br><br>
    </div>

    @if (session('mensaje'))
        <div class="">
            <div class="" style="background-color: gray">
                <p> {{ session('mensaje') }} </p>
            </div>
        </div>
    @endif

    <div class="listado">
        @foreach ($perteneces as $pertenece)
            <div class="tarjeta">
                <ul>
                    <li><a href="{{ route('pertenece.show', $pertenece) }}" >ID:</a> {{ $pertenece->id }}</li>
                    <li>Alumno ID: {{ $pertenece->alumno_id }} - {{ $pertenece->alumno->nombre }}</li>
                    <li>Curso ID: {{ $pertenece->curso_id }} - {{ $pertenece->curso->nombre }}</li>
                </ul>

                <div class="botones">
                    <a href="{{ route('pertenece.show', $pertenece) }}" class="boton">Ver</a>
                    <a href="{{ route('pertenece.edit', $pertenece) }}" class="boton">Editar</a>

                    <form action="{{ route('pertenece.destroy', $pertenece)}}" method="POST" id="eliminar">
                        @csrf @method('DELETE')
                        <button class="boton" type="submit">Borrar</button>
                    </form>

                    <a href="{{ route('pertenece.confirmar', $pertenece) }}" class="boton"> Eliminar 2 </a>
                </div>
            </div>
        @endforeach
    </div>
@endsection

resources/views/pertenece/show.blade.php
@extends('layouts.main')

@section('content')
    <h1>Listado Pertenece</h1>

    <div>
        <a href="{{ route('pertenece.index') }}" class="boton">Volver</a><br><br>
    </div>

    @if (session('mensaje'))
        <div class="">
            <div class="" style="background-color: gray">
                <p> {{ session('mensaje') }} </p>
            </div>
        </div>
    @endif

    <div class="listado">
        <div class="tarjeta">
            <ul>
                <li>ID: {{ $pertenece->id }}</li>
                <li>ID Alumno: {{ $pertenece->alumno_id }} - {{ $pertenece->alumno->nombre }}</li>
                <li>Curso ID: {{ $pertenece->curso_id }} - {{ $pertenece->curso->nombre }}</li>
            </ul>

            <div class="botones">
                <a class="boton" href="{{ route('pertenece.edit', $pertenece) }}">Editar</a>

                <form action="{{ route('pertenece.destroy', $pertenece)}}" method="POST" id="eliminar">
                    @csrf @method('DELETE')
                    <button class="boton" type="submit">Borrar</button>
                </form>

                <a href="{{ route('pertenece.confirmar', $pertenece) }}" class="boton"> Eliminar 2 </a>
            </div>
        </div>
    </div>
@endsection